Bug 1022829 - Task delegation UI improvements
Task delegation UI improvements
Status: CLOSED CURRENTRELEASE
Product: JBoss BPMS Platform 6
Classification: JBoss
Component: Business Central (Show other bugs)
6.0.0
Unspecified Unspecified
high Severity medium
: ER6
: 6.0.0
Assigned To: Mauricio Salatino
Jan Hrcek
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-10-24 02:45 EDT by Jan Hrcek
Modified: 2014-08-06 16:12 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-08-06 16:12:51 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Steps to reproduce - video (4.09 MB, video/webm)
2013-10-24 02:45 EDT, Jan Hrcek
no flags Details

  None (edit)
Description Jan Hrcek 2013-10-24 02:45:15 EDT
Created attachment 815637 [details]
Steps to reproduce - video

Description of problem:
After delegation is performed in task list using task's Details>Assignments panel, user remains listed in the 'Potential Owners' field, but he has no longer access to that task's actions (he cannot claim it/start/complete it)

See video attached for steps to reproduce this problem.

Version-Release number of selected component (if applicable):
BPMS 6.0.0 ER4

How reproducible:
Always

Steps to Reproduce:
1. Go to tasks list, create new task
2. Using details button (magnifying glass) go to Details panel and there, switch to Assignments
3. Fill in some user or group (also please notice, that this field accepts empty input)
4. Click Delegate button

Actual results:
-Current user remains listed in Potential owners list
-Current user can no longer perform actions on task - he can only go to details.

Expected results:
Either 
1) current user should be removed from potential owners list (in such case also Delegate button should be disabled - as it is he can still click this button, resulting in error notifications being displaed)
2) or current user should still be able to claim back the task and perform other actions on it.

Additional info:
Also please make sure some elementary validation is implemented for User or Group field - as it is now, it accepts empty input.
Comment 1 Kris Verlaenen 2013-10-24 18:16:14 EDT
This is actually how delegation is supposed to work according to the WS-HumanTask specification (section 4.7.3).  Only when a task is forwarded (instead of delegated) the user should be removed from the potential owner list (this is however not yet possible in the UI).
Once a task is reserved (claimed by or assigned to a specific user), the other potential owners are no longer able to claim the task (as this is only possible if the task is in ready state).  Only when the actual owner would release the task again, all potential owners would again be able to claim the task.

As a result, I believe the current implementation behaves as the specification dictates.
Comment 2 Jan Hrcek 2013-10-24 23:05:48 EDT
Kris, if that is the case in WS-HT spec, then leaving the user in potential owner list is OK. However, there are still the other 2 issues mentioned that are present in ER4 and need to be looked at: 

1) after delegation is performed the Delegate button should be disabled (to prevent errors that appear when user repeatadely clicks on the Delebate button)

2) input validation - empty string should not be accepted when entering User or group input.
Comment 3 Kris Verlaenen 2013-10-24 23:13:51 EDT
Jan, agreed, I've updated the title to reflect this.
Comment 4 Mauricio Salatino 2013-11-20 12:53:17 EST
This is already fixed in 6.0.x, I'm marking this BZ as modified
This commit fixes the issues described here in the last comments: https://github.com/droolsjbpm/jbpm-console-ng/commit/adf2866728faae1052044426be02ff8ca416433d
Comment 5 Jan Hrcek 2014-01-02 06:18:08 EST
Ok, verified with BPMS 6.0.0 ER6

Note You need to log in before you can comment on or make changes to this bug.